//++
//|                                                JQS UGA_script v1.1.0 |
//|                                       Copyright  2010, JQS aka Joo. |
//|                                     http://www.mql4.com/ru/users/joo |
//++
#property copyright "Copyright  2010, JQS aka Joo."                   //|
#property link      "http://www.mql4.com/ru/users/joo"                 //|
//++
#property description "The script that demonstrates the functioning "  //|
#property description "of the Universal Genetic Algorithm UGAlib library"
#property description "that uses the representation of chromosome"     //|
#property description "using real numbers"                             //|
//++
#property script_show_inputs                                           //|
//++
#include "UGAlib.mqh"
#include "Skin.mqh" //test function
//++

//
//----------------------Input Variables--------------------------------
input string GenofundParam         =        "----Parameters of gene pool----";
input int    ChromosomeCount_P     = 50;    //Number of chromosomes in colony
input int    GeneCount_P           = 2;     //Number of genes
input int    Epoch_P               = 50;    //Number of epochs without improvement
//---
input string GA_OperatorParam      =        "----Parameters of operators----";
input double ReplicationPortion_P  = 100.0; //Portion of replication.
input double NMutationPortion_P    = 10.0;  //Portion of natural mutation.
input double ArtificialMutation_P  = 10.0;  //Portion of artificial mutation.
input double GenoMergingPortion_P  = 20.0;  //Portion of adoption of genes.
input double CrossingOverPortion_P = 20.0;  //For crossing over.
//---
input double ReplicationOffset_P   = 0.5;   //Rate of shifting the interval borders
input double NMutationProbability_P= 5.0;   //Probability of mutation of each gene in %
//---
input string OptimisationParam     =        "----Optimization parameters----";
input double RangeMinimum_P        = -5.0;  //Minimum of the search range
input double RangeMaximum_P        = 5.0;   //Maximum of the search range
input double Precision_P           = 0.0001;//Necessary precision
input int    OptimizeMethod_P      = 1;     //Optim.:1-Min,other-Max
//

//
//----------------------Global Variables-----------------------------
double ERROR=0.0;//Average error per gene
//

//
//--------------------------Program Body--------------------------------
int OnStart()
{
  //-----------------------Variables-------------------------------------
  //Preparation of global variables for UGA
  ChromosomeCount=ChromosomeCount_P;          //Number of chromosomes in colony
  GeneCount      =GeneCount_P;                //Number of genes
  RangeMinimum   =RangeMinimum_P;             //Minimum of the search range
  RangeMaximum   =RangeMaximum_P;             //Maximum of the search range
  Precision      =Precision_P;                //Search step
  OptimizeMethod =OptimizeMethod_P;           //1-minimum, any other-maximum  
  ArrayResize(Chromosome,GeneCount+1);
  ArrayInitialize(Chromosome,0);
  Epoch=Epoch_P;                              //Number of epochs without improvement
  //----------------------------------------------------------------------
  //Local variables
  int time_start=(int)GetTickCount(),time_end=0;
  //----------------------------------------------------------------------

  //Start of main function of UGA
  UGA
  (
  ReplicationPortion_P, //Portion of replication.
  NMutationPortion_P,   //Portion of natural mutation.
  ArtificialMutation_P, //Portion of artificial mutation.
  GenoMergingPortion_P, //Portion of adoption of genes.
  CrossingOverPortion_P,//Portion of crossing over.
  //---
  ReplicationOffset_P,  //Rate of shifting the interval borders
  NMutationProbability_P//Probability of mutation of each gene in %
  );
  //----------------------------------
  time_end=(int)GetTickCount();
  //----------------------------------
  Print(time_end-time_start,"  - Time of execution");
  //----------------------------------
  return(0);
}
//
